package Test.Domain;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Test;

import Domain.Kartenstapel;
import Domain.Enums.Kartenfarbe;
import Domain.Karten.Karte;
import Domain.Karten.Magierkarte;
import Domain.Karten.Narrenkarte;
import Domain.Karten.Zahlenkarte;

class KartenstapelTest {

	@Test
	void testKartenstapelSortiert() {
		Kartenstapel k = new Kartenstapel();
		
		System.out.println(k.getKartenstapelSortiert());
		k.mischen();
		System.out.println(k.getKartenstapelGemischt());
		System.out.println(k.getStatusGemischt());
		// Test der richtigen Klassen
		assertInstanceOf(Magierkarte.class, k.getKartesortiert(1));
		assertInstanceOf(Magierkarte.class, k.getKartesortiert(4));
		assertInstanceOf(Narrenkarte.class, k.getKartesortiert(5));
		assertInstanceOf(Narrenkarte.class, k.getKartesortiert(8));
		assertInstanceOf(Zahlenkarte.class, k.getKartesortiert(9));
		assertInstanceOf(Zahlenkarte.class, k.getKartesortiert(17));
		assertInstanceOf(Zahlenkarte.class, k.getKartesortiert(26));
		assertInstanceOf(Zahlenkarte.class, k.getKartesortiert(45));
		assertInstanceOf(Zahlenkarte.class, k.getKartesortiert(60));
		
		// Test der richtigen Bezeichnungen für Magierkarten und Narrenkarten
		assertTrue("Zauberer" == ((Magierkarte) k.getKartesortiert(2)).getName());
		assertTrue("Narr" == ((Narrenkarte) k.getKartesortiert(5)).getName());
		
		// Test der richtigen Werte auf den Zahlenkarten
		// Charakterkarte MENSCH
		assertTrue(1 == ((Zahlenkarte) k.getKartesortiert(9)).getKartenwert());
		assertTrue(13 == ((Zahlenkarte) k.getKartesortiert(21)).getKartenwert());
		assertEquals(Kartenfarbe.MENSCH.getFarbe(), ((Zahlenkarte) k.getKartesortiert(17)).getCharakter().getFarbe());
		assertTrue(9 == ((Zahlenkarte) k.getKartesortiert(17)).getKartenwert());
		
		// Charakterkarte ELF
		assertTrue(1 == ((Zahlenkarte) k.getKartesortiert(22)).getKartenwert());
		assertTrue(13 == ((Zahlenkarte) k.getKartesortiert(34)).getKartenwert());
		assertEquals(Kartenfarbe.ELF.getFarbe(), ((Zahlenkarte) k.getKartesortiert(25)).getCharakter().getFarbe());
		assertTrue(4 == ((Zahlenkarte) k.getKartesortiert(25)).getKartenwert());
		
		// Charakterkarte RIESE
		
		
		// Charakterkarte ZWERG
		
		
	}

}
